<?php

add_action( 'admin_menu', 'idea_push_remove_metaboxes');
function idea_push_remove_metaboxes(){
    remove_meta_box('statusdiv', 'idea', 'normal');
    remove_meta_box('boardsdiv', 'idea', 'normal');
}





 add_action( 'add_meta_boxes', 'idea_push_add_metaboxes');
 function idea_push_add_metaboxes() {
     add_meta_box( 'status-div', 'Status','idea_push_status_metabox','idea' ,'side','core');
     add_meta_box( 'boards-div', 'Board','idea_push_boards_metabox','idea' ,'side','core');
     add_meta_box( 'votes-div', 'Votes','idea_push_votes_metabox','idea' ,'side','core');
 }


function idea_push_votes_metabox( $post ) {
    
    wp_nonce_field( basename( __FILE__ ), 'votes_meta_box_nonce' );
    
    $existingVotes = get_post_meta($post->ID, 'votes', true);	
	
    echo '<div class="inside"><p>';
        
    echo '<input type="number" name="votes" min="" max="" value="'.$existingVotes.'">';
        
    echo '</p></div>';      
    
}


function idea_push_save_votes_metabox( $post_id ){
	
    if ( !isset( $_POST['votes_meta_box_nonce'] ) || !wp_verify_nonce( $_POST['votes_meta_box_nonce'], basename( __FILE__ ) ) ){
        return;
    }
    
    
    if ( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE ){
	   return;
    }
    
    if ( ! current_user_can( 'edit_post', $post_id ) ){
        return;
    }
    
    if ( isset( $_REQUEST['votes'] ) ) {
        update_post_meta( $post_id, 'votes', sanitize_text_field( $_POST['votes'] ) );
    }

  
}
add_action( 'save_post_idea', 'idea_push_save_votes_metabox', 10, 2 );



 
function idea_push_status_metabox( $post ) {
    //Get taxonomy and terms
    $taxonomy = 'status';
    
    //get options
    $options = get_option('idea_push_settings'); 
    
    //Set up the taxonomy object and get terms
    $tax = get_taxonomy($taxonomy);
    $terms = get_terms($taxonomy,array('hide_empty' => 0));
 
    //Name of the form
    $name = 'tax_input[' . $taxonomy . ']';
 
    //Get current and popular terms
    $postterms = get_the_terms( $post->ID,$taxonomy );
    $current = ($postterms ? array_pop($postterms) : false);
    $current = ($current ? $current->term_id : 0);
    ?>
 
    <div id="taxonomy-<?php echo $taxonomy; ?>" class="categorydiv">
 
 
        <!-- Display taxonomy terms -->
        <div id="<?php echo $taxonomy; ?>-all" class="tabs-panel">
            <ul id="<?php echo $taxonomy; ?>checklist" class="list:<?php echo $taxonomy?> categorychecklist form-no-clear">
                <?php   foreach($terms as $term){
                    
                    //remove disabled statuses
                    
                    if(isset($options['idea_push_disable_approved_status']) && $term->slug == 'approved'){
                        continue;
                    }
        
                    if(isset($options['idea_push_disable_declined_status']) && $term->slug == 'declined'){
                        continue;
                    }
        
                    if(isset($options['idea_push_disable_inprogress_status']) && $term->slug == 'in-progress'){
                        continue;
                    }
        
                    if(isset($options['idea_push_disable_completed_status']) && $term->slug == 'completed'){
                        continue;
                    }
        

                    $id = $taxonomy.'-'.$term->term_id;
                    echo "<li id='$id'><label class='selectit'>";
                    echo "<input type='radio' id='in-$id' name='{$name}'".checked($current,$term->term_id,false)."value='$term->term_id' />$term->name<br />";
                   echo "</label></li>";
        
        
        
                }?>
           </ul>
        </div>
 
 
    </div>
    <?php
}



function idea_push_boards_metabox( $post ) {
    //Get taxonomy and terms
    $taxonomy = 'boards';
 
    //Set up the taxonomy object and get terms
    $tax = get_taxonomy($taxonomy);
    $terms = get_terms($taxonomy,array('hide_empty' => 0));
 
    //Name of the form
    $name = 'tax_input[' . $taxonomy . ']';
 
    //Get current and popular terms
    $postterms = get_the_terms( $post->ID,$taxonomy );
    $current = ($postterms ? array_pop($postterms) : false);
    $current = ($current ? $current->term_id : 0);
    ?>
 
    <div id="taxonomy-<?php echo $taxonomy; ?>" class="categorydiv">
 
 
        <!-- Display taxonomy terms -->
        <div id="<?php echo $taxonomy; ?>-all" class="tabs-panel">
            <ul id="<?php echo $taxonomy; ?>checklist" class="list:<?php echo $taxonomy?> categorychecklist form-no-clear">
                <?php   foreach($terms as $term){
                    $id = $taxonomy.'-'.$term->term_id;
                    echo "<li id='$id'><label class='selectit'>";
                    echo "<input type='radio' id='in-$id' name='{$name}'".checked($current,$term->term_id,false)."value='$term->term_id' />$term->name<br />";
                   echo "</label></li>";
                }?>
           </ul>
        </div>
 
 
    </div>
    <?php
}



?>