<?php

// a common function to create a user
function idea_push_create_user_common($firstName,$lastName,$email){
    
    
    $ipAddress = idea_push_get_ip_address();
    
    //for now we are going to force create the role
    remove_role( 'idea_push_guest' );
    add_role( 'idea_push_guest', 'IdeaPush Guest', array('read' => true, 'level_1' => true ));
        
    
    //sanitise and validate input
    $firstName = idea_push_sanitization_validation($firstName,'name'); 
    $lastName = idea_push_sanitization_validation($lastName,'name');
    $email = idea_push_sanitization_validation($email,'email');
    
    if($firstName == false || $lastName == false || $email == false){
        return 'The input is not valid';
    }
    
    
    $userdata = array(
        'user_login'  =>  strtolower($firstName).'-'.strtolower($lastName).'-'.$ipAddress,
        'display_name'  =>  $firstName,
        'nickname'  =>  $firstName,
        'first_name'  =>  $firstName,
        'last_name'  =>  $lastName,
        'role'  =>  'idea_push_guest',
//        'role'  =>  'contributor',
        'description'  =>  'This user was created automatically by the IdeaPush plugin.',
        'user_email'  =>  $email,
        'user_pass'   =>  NULL  // When creating an user, `user_pass` is expected.
    );

    $user_id = wp_insert_user($userdata);

    //if its an error, return false
    if(is_wp_error( $user_id ) ){
        return false;
    }


    //now add ip meta
    add_user_meta($user_id, 'ip_address', $ipAddress); 
    
    return $user_id;

}






function idea_push_create_user(){
    
    $firstName = idea_push_sanitization_validation($_POST['firstName'],'name');
    $lastName = idea_push_sanitization_validation($_POST['lastName'],'name');
    $email = idea_push_sanitization_validation($_POST['email'],'email');
    
    if($firstName == false || $lastName == false || $email == false){
        wp_die(); 
    }
    
    
    echo idea_push_create_user_common($firstName,$lastName,$email);
    
    wp_die();    
}

add_action( 'wp_ajax_create_user', 'idea_push_create_user' );
add_action( 'wp_ajax_nopriv_create_user', 'idea_push_create_user' );



?>