<?php

function idea_push_send_email($to,$subject,$body){
    
    $headers = array('Content-Type: text/html; charset=UTF-8');
    
    wp_mail($to, $subject, $body, $headers);   
    
}


//check to see if email is valid
function idea_push_is_email_valid($email){
    
    if(strlen($email)>0 && strpos($email, '@') !== false){
        return true;
    } else {
        return false;
    }
    
}



function idea_push_shortcode_replacement($ideaId,$setting,$voterId){
    
    //lets do various operations
    
    //do some standard variables
    $postAuthorId = get_post_field( 'post_author', $ideaId );
    $postAuthor = get_user_by('id',$postAuthorId);
    
    $boardSettings = idea_push_get_board_settings(idea_push_get_board_id_from_post_id($ideaId));
    
    $postContent = htmlentities(strip_tags(get_post_field('post_content',$ideaId,'raw'))); 
    
    
    
    
    // 1. replace the title
    $setting = str_replace('[Idea Title]',get_the_title($ideaId),$setting); 
    
    // 2. replace author first name
    $setting = str_replace('[Author First Name]',$postAuthor->first_name,$setting);
    
    // 3. replace author last name
    $setting = str_replace('[Author Last Name]',$postAuthor->last_name,$setting);
    
    // 4. replace board name
    $setting = str_replace('[Board Name]',$boardSettings[1],$setting);
    
    // 5. replace the content
    $setting = str_replace('[Idea Content]',$postContent,$setting);
    
    // 6. replace the link
    $setting = str_replace('[Idea Link]',get_post_permalink($ideaId),$setting);
    
    // 7. replace vote count
    $setting = str_replace('[Vote Count]',get_post_meta($ideaId,'votes',true),$setting);
    
    // 8. do voter name replacement
    if(strlen($voterId)>0){
        
        $voter = get_user_by('id',$voterId);
        
        // 8. replace voter first name
        $setting = str_replace('[Voter First Name]',$voter->first_name,$setting);
        
        // 9. replace voter last name
        $setting = str_replace('[Voter Last Name]',$voter->last_name,$setting);
  
    }
    
    
    // 9. replace the edit link
    $setting = str_replace('[Idea Edit Link]',get_admin_url().'post.php?post='.$ideaId.'&action=edit',$setting);
    

    return $setting;
    
}












//this function sanitizes and validates input to improve security
function idea_push_sanitization_validation($data,$type){
    
    //types include email, name, post id, board name
    
    //if the data is LOGGED-IN MAKE IT PASS
    if($data == 'LOGGED-IN'){
        return $data;     
    }
    
    
    
    //first sanitize inputs
    if($type == 'email'){
        $data = sanitize_email($data);      
    } elseif ($type == 'name'){
        $data = sanitize_text_field($data);    
    } elseif($type == 'id') {
        $data = sanitize_text_field($data);  
    } elseif($type == 'boardname'){
        $data = sanitize_text_field($data);    
    } else { 
    }
    
    return $data;
    
    
    //lets now validate the input
   
    if($type == 'email' && strlen($data) > 254 && strpos($data, '@') === false){
        
        return false;

    } elseif ($type == 'name' && 1 === preg_match('~[0-9]~', $data)){
        
        return false;    
        
    } elseif ($type == 'id' && strlen($data) > 9 && is_numeric($data) == false) {
        
        return false;      
        
    } elseif($type == 'boardname' && strlen($data) > 254) {
        
        return false;    
        
    } else {
        
        return $data;
        
    }
     
}



//gets the users ip address
function idea_push_get_ip_address(){
                                    
    if ( ! empty( $_SERVER['HTTP_CLIENT_IP'] ) ) {
        return $_SERVER['HTTP_CLIENT_IP'];    
    } elseif(! empty( $_SERVER['HTTP_X_FORWARDED_FOR'] )) {
        return $_SERVER['HTTP_X_FORWARDED_FOR'];     
    } else {
        return $_SERVER['REMOTE_ADDR'];    
    }

}





//returns user id if logged in or returns false if logged out
function idea_push_check_if_non_logged_in_user_is_guest(){
    
    
    if(is_user_logged_in()){
                            
        $current_user = wp_get_current_user();
        
        //returns current user id
        $userIpMatchFound =  $current_user->ID;
                            
    } else {
    
        //get current visitors ip address
        $currentVisitorIP = idea_push_get_ip_address();

        //user is not logged in, lets check the user meta to see if their IP is associated with a user account
        $allIdeaPushUsers = get_users( array( 'role' => 'idea_push_guest' ) );

        $userIpMatchFound = false;

        // Array of WP_User objects.
        foreach ($allIdeaPushUsers as $ideaPushUser) {

            $userID = $ideaPushUser->ID;

            $userIP = get_user_meta($userID,'ip_address',true);

            if($userIP == $currentVisitorIP){
                //returns user id from lookup
                $userIpMatchFound = $userID;
                break;    
            }

        }
        
    }
    
    return $userIpMatchFound;
   
}










function idea_push_check_if_non_logged_in_user_is_guest_frontend(){
    
    echo idea_push_check_if_non_logged_in_user_is_guest();
    wp_die(); 
}
add_action( 'wp_ajax_is_person_logged_in', 'idea_push_check_if_non_logged_in_user_is_guest_frontend' );
add_action( 'wp_ajax_nopriv_is_person_logged_in', 'idea_push_check_if_non_logged_in_user_is_guest_frontend' );



function idea_push_is_person_able_to_add_tag(){
    
    $options = get_option('idea_push_settings');

    if(isset($options['idea_push_disable_user_tag_creation'])){
        $disableUserTagCreation = $options['idea_push_disable_user_tag_creation'];  
    } else {
        $disableUserTagCreation = '';    
    }
    
    echo $disableUserTagCreation;
    
    wp_die(); 
}
add_action( 'wp_ajax_is_person_able_to_add_tag', 'idea_push_is_person_able_to_add_tag' );
add_action( 'wp_ajax_nopriv_is_person_able_to_add_tag', 'idea_push_is_person_able_to_add_tag' );










function idea_push_get_board_settings($boardId){
    
    $options = get_option('idea_push_settings');

    $boardSettings = $options['idea_push_board_configuration'];
        
    $explodeBoardSettings = explode('||',$boardSettings);

    foreach ($explodeBoardSettings as $boardSetting){

        //explode the settings again
        $explodeBoardSetting = explode('|',$boardSetting);

        if($explodeBoardSetting[0] == $boardId) {
            return $explodeBoardSetting; 
        }

    }
    
    //we can just put anything here but not an Array!
    return 'Nothing found';

}











//gets the user avatar
function idea_push_get_user_avatar($userId){

//    $avatarArgs = array( 
//                    'size' => 70, 
//                    'default' => 404, 
//                ); 
//
//
//    $imageUrl = get_avatar_url($userId,$avatarArgs);
//
//    $checkForError = wp_remote_post($imageUrl);
    
 
//    if(wp_remote_retrieve_response_code( $checkForError ) == 404 ){
//
//        $imageUrl = plugins_url( '../images/default-image.png', __FILE__ );
//
//    }
    
    
    $imageUrl = get_user_meta($userId, 'ideaPushImage', true);
    
    

    if(empty($imageUrl)){

        $imageUrl = plugins_url( '../images/default-image.png', __FILE__ );

    }

    return $imageUrl;
    
}













//gets board id from post id
function idea_push_get_board_id_from_post_id($postId){
    
    
    $getTerms = get_the_terms($postId,'boards');
    
    foreach($getTerms as $term) {
        $boardId = $term->term_id;    
    }
    
    return $boardId;
    
}















function idea_push_header_render(){
    
    
    $boardNumber = idea_push_sanitization_validation($_POST['boardNumber'],'id');
    $showing = sanitize_text_field($_POST['showing']);
    
    if($boardNumber == false){
        wp_die();      
    }
    
    
    echo idea_push_header_render_output($boardNumber,$showing); 
    wp_die();
}

add_action( 'wp_ajax_header_render', 'idea_push_header_render' );
add_action( 'wp_ajax_nopriv_header_render', 'idea_push_header_render' );



function idea_push_form_render(){
    
    $boardNumber = idea_push_sanitization_validation($_POST['boardNumber'],'id');
    
    if($boardNumber == false){
        wp_die();       
    }
    
    echo idea_push_form_render_output($boardNumber);
    
    wp_die();
}

add_action( 'wp_ajax_form_render', 'idea_push_form_render' );
add_action( 'wp_ajax_nopriv_form_render', 'idea_push_form_render' );




//function to count posts pending status
function idea_push_count_pending_ideas() {
    
    $args = array(
        'numberposts'   => -1,
        'post_type'     => 'idea',
        'post_status'   => 'pending',
    );
    
    $count_posts = count( get_posts( $args ) ); 
    return $count_posts;
}

//function to count posts pending status
function idea_push_count_ideas_review_status() {
    
    $args = array(
        'numberposts'   => -1,
        'post_type'     => 'idea',
        'post_status'   => 'publish',
        'tax_query' => array(
            array(
                'taxonomy' => 'status',
                'field'    => 'slug',
                'terms'    => array('reviewed')
            )
        )
    );
    
    $count_posts = count( get_posts( $args ) ); 
    return $count_posts;
}



//checks whether user is an admin
function idea_push_is_user_admin($userId){
    
    $user = get_user_by('id', $userId);
    
    $userRoles = $user->roles;   
    
    if(in_array('administrator',$userRoles)){     
        return true;
    } else {
        return false;
    }

}




//this function returns an array of positive or negative voters but also initialises a meta value or reformulates if it is legacy
function idea_push_get_voter_array($ideaId,$upOrDown){
    
    $existingVoters = get_post_meta($ideaId,$upOrDown,true);
    
    if(is_array($existingVoters)){
            
            //lets do nothing as everything is good and in the new format

    } elseif (empty($existingVoters)){

        //lets update the meta with an empty array
        update_post_meta( $ideaId, $upOrDown, array());

    } else {

        //theres existing values but in the older format, so lets put this into the new format
        //we can consider removing this after sometime
        $updatedMeta = array();
        $explodedUsers = explode(',',$existingVoters);

        foreach($explodedUsers as $user){
            if($user !== ''){
                $currentTime = current_time( 'timestamp', 0 ); 
                array_push($updatedMeta,array(intval($user),$currentTime));      
            }
        }

        update_post_meta( $ideaId, $upOrDown, $updatedMeta);

    }

    //return updated value
    return get_post_meta($ideaId,$upOrDown,true);
 
}







?>