<?php
// shortcode
function idea_push_board_shortcode($atts) {
    
    //get options
    $options = get_option('idea_push_settings');
    
    //get is pro
    global $ideapush_is_pro;

    //set a default attribute for board
    $a = shortcode_atts(array('board' => ''),$atts);
    



    /**
    * 
    *
    *
    * Get the query strings and if there are no query strings setting the defaults set another value instead
    */


    //get query strings
    if(isset($_GET['showing'])){
        $defaultShowing = sanitize_text_field($_GET['showing']);
    } else {
        $defaultShowing = 'popular';    
    }








    
    if(isset($_GET['status'])){
        $defaultStatus = sanitize_text_field($_GET['status']);
    } else {
        $defaultStatus = 'open';    
    }

    if(isset($_GET['tag'])){
        $defaultTag = sanitize_text_field($_GET['tag']);

        //now lets get the tag id from the name
        //first we are going to check with a board prefix and if this fails get it without

        if($defaultTag == 'All'){
            $defaultTag = 'all'; 
        } else {

            if(get_term_by( 'name', $defaultTag, 'tags') == false){
                $defaultTag = get_term_by( 'name', 'BoardTag-'.$a['board'].'-'.$defaultTag, 'tags');
            } else {
                $defaultTag = get_term_by( 'name', $defaultTag, 'tags');
            }
    
            $defaultTag = $defaultTag->term_id;

        }

    } else {
        $defaultTag = 'all';    
    }

    












    
    
    //only do something if the board property is populated
    if(strlen($a['board'])>0){
        
        
        $individualBoardSetting = idea_push_get_board_settings($a['board']);
        
        //check if is array, that is, whether a setting was found
        if(is_array($individualBoardSetting)){
            
            
            //lets create standard variables for the settings
            $boardId = $individualBoardSetting[0];
            $boardName = $individualBoardSetting[1];
            $voteThreshold = $individualBoardSetting[2];
            $holdIdeas = $individualBoardSetting[3];
            $showComments = $individualBoardSetting[4];
            $showTags = $individualBoardSetting[5];
            $showAttachments = $individualBoardSetting[6];
            $showBoardTitle = $individualBoardSetting[7];
            $showVoteTarget = $individualBoardSetting[8];
            $guestAccess = $individualBoardSetting[9];
            $downVoting = $individualBoardSetting[10];
            $showBoardTo = $individualBoardSetting[14];
            $formSettings = $individualBoardSetting[23];
            
            //only get the following settings if pro
            if($ideapush_is_pro == 'YES'){
                $enableChallenge = $individualBoardSetting[16];
                $challengeVictory = $individualBoardSetting[17];
                $challengeDate = $individualBoardSetting[18];
                $challengeTime = $individualBoardSetting[19];
                $challengeMessage = $individualBoardSetting[20];
                $challengeVictoryMessage = $individualBoardSetting[21];    
            }
            
            
            
            
            //lets call this function once and use throughout
            //this function will reutn the user id or false
            
            $currentUserId = idea_push_check_if_non_logged_in_user_is_guest();
            
            //echo 'The user id is: '.$currentUserId.'</br>'; 
            
            //checking whether the user exists or not
            if($currentUserId !== false){
                $currentUserObject = get_user_by( 'id', $currentUserId);
                $currentUserRole = $currentUserObject->roles;
                
                //echo 'The user roles are: '.implode(",", $currentUserRole).'</br>'; 
                
                //the error is saying the currentuserrole is not an array and it's null
                
                if(in_array($showBoardTo, $currentUserRole)){
                    $userRoleCheck = true;
                } else {
                    $userRoleCheck = false;   
                }
                
            } else {
                $userRoleCheck = false;     
            }
            

            
            
            //only show the board if the person is allowed to see it
            if($userRoleCheck || $showBoardTo == "Everyone"){
 
                //lets create our holding variable
                $html = '';

                $primaryColor = esc_html($options['idea_push_primary_link_colour']);

                //lets output some css
                $html .= '<style>


                .ideapush-container i, .ideapush-container a, .ideapush-container .idea-item-tag:hover, .ideapush-container .idea-item-file:hover, .ideapush-dialog .close-button, .ideapush-dialog-image .close-button, .idea-page-number.active,.idea-page-number:hover
                {color: '.$primaryColor.';}




                .ideapush-container .idea-item-tag:hover, .ideapush-container .idea-item-file:hover, .ideapush-dialog .ui-button,.ideapush-dialog .ui-button:hover,.ideapush-dialog .ui-button:focus, .ideapush-dialog .close-button, .ideapush-dialog-image .close-button, .idea-page-number.active,.idea-page-number:hover, .ideapush-container .challenge-message-box
                {border-color: '.$primaryColor.';}



                .submit-new-idea,.submit-new-idea:hover,.submit-new-idea:focus, .update-user-profile,.update-user-profile:hover,.update-user-profile:focus, .ideapush-dialog .ui-button,.ideapush-dialog .ui-button:hover,.ideapush-dialog .ui-button:focus, .admin-star-outer,.admin-star-outer-large, .create-idea-form-reveal,.create-idea-form-reveal:hover,.create-idea-form-reveal:focus, .ideapush-container .challenge-message-box
                {background-color: '.$primaryColor.';}

                .alertify .cancel
                {color: '.$primaryColor.' !important;}

                .alertify .ok, .alertify .cancel
                {border-color: '.$primaryColor.' !important;}

                .alertify .ok
                {background-color: '.$primaryColor.' !important;}


                </style>';



                $html .= '<div class="ideapush-container" data="'.esc_attr($boardId).'">';

                    //header
                    $html .= '<div class="ideapush-container-header">';

                        //board title
                        //only show board title if it is nominated in the settings
                        if($showBoardTitle == 'Yes'){
                            $html .= '<h2 class="ideapush-board-title">'.esc_html($boardName).'</h2>';    
                        }

                        //board target
                        //only show board title if it is nominated in the settings
                        if($showVoteTarget == 'Yes'){
                            $html .= '<div class="ideapush-vote-target">'.__( 'Get your idea to', 'ideapush' ).' '.esc_html($voteThreshold).' '.__( 'to be reviewed', 'ideapush' ).'</div>';    
                        }

                

                    $html .= '</div>';


                    if($guestAccess == "Yes" || $currentUserId !== false){
                        $additionalContainerClass = '';   
                    } else {
                        $additionalContainerClass = ' ideapush-container-ideas-full-width';       
                    }

                    //ideas
                    $html .= '<div class="ideapush-container-ideas'.esc_attr($additionalContainerClass).'">';

                        $html .= '<div class="ideapush-container-idea-header">'; //put border below me
                
                            //show challenge box    
                            if($ideapush_is_pro == 'YES' && isset($enableChallenge) && $enableChallenge == 'Yes' && strtotime(current_time('mysql')) <= strtotime($challengeDate.' '.$challengeTime.':00') ){
                                $html .= idea_push_challenge_message($individualBoardSetting);  
                            }

                            //show challenge vicotry box    
                            if($ideapush_is_pro == 'YES' && isset($enableChallenge) && $enableChallenge == 'Yes' && strtotime(current_time('mysql')) > strtotime($challengeDate.' '.$challengeTime.':00') ){
                                $html .= idea_push_challenge_victory_message($individualBoardSetting);  
                            }
                            

                            //fetch header
                            $html .= idea_push_header_render_output($a['board'],$defaultShowing);


                        $html .= '</div>'; //end header


                        //dynamic data
                        $html .= '<ul class="dynamic-idea-listing" data="'.esc_attr($boardId).'">';

                            $html .= idea_push_list_items($boardId,$defaultShowing,$defaultStatus,$defaultTag);

                        $html .= '</ul>';

                    $html .= '</div>';



                    //don't show the whole form section if guest voting new ideas isn't enabled
                    if($guestAccess == "Yes" || $currentUserId !== false){
                        

                        //only show the whole form section if not pro or challenge enabled and challenge expiry hasn't been reached
                        if(($ideapush_is_pro == 'NO') || (!isset($enableChallenge)) || ($ideapush_is_pro == 'YES' && $enableChallenge == 'No') || ($ideapush_is_pro == 'YES' && $enableChallenge == 'Yes' && strtotime(current_time('mysql')) < strtotime($challengeDate.' '.$challengeTime.':00'))      ){
                            
                            $currentOption = $options['idea_push_form_settings'];

                            $explodedOptions = explode('||||',$currentOption);

                            //gets the submit idea button text from the specific form settings
                            foreach($explodedOptions as $formSetting){

                                $explodedSubOptions = explode('|||',$formSetting);
                        
                                $settingName = $explodedSubOptions[0];
                        
                                if($settingName == $formSettings){
                        
                                    $standardFormLabels = $explodedSubOptions[1];

                                    $standardFormLabelsExploded = explode('||',$standardFormLabels);

                                }
                            }  

                            if(isset($standardFormLabelsExploded[6]) && strlen($standardFormLabelsExploded[6])>1){
                                $ideaButtonText = esc_html($standardFormLabelsExploded[6]);    
                            } else {
                                $ideaButtonText = __( 'Submit new idea', 'ideapush' ); 
                            }

                            $html .= '<button class="create-idea-form-reveal">'.$ideaButtonText.'</button>';

                            //form
                            $html .= '<div class="ideapush-container-form">';

                                $html .= idea_push_form_render_output($a['board']);    

                            $html .= '</div>'; //end container    
                             
                        }
                            
                    } //end condition if guest 

                $html .= '</div>'; //end whole idea page section



                //output dialogs
                //published dialog
                $html .= '<div style="display: none;" id="dialog-idea-published" data="'.__( 'Idea submitted successfully, now showing your ideas', 'ideapush' ).'"></div>';

                //reviewed dialog
                $html .= '<div style="display: none;" id="dialog-idea-reviewed" data="'.__( 'Your idea has been submitted and will be reviewed soon', 'ideapush' ).'"></div>';

                //recaptcha fail dialog
                $html .= '<div style="display: none;" id="dialog-recaptcha-fail" data="'.__( 'Please make sure the reCAPTCHA is validated and all fields are completed', 'ideapush' ).'"></div>';
                
                //math fail dialog
                $html .= '<div style="display: none;" id="dialog-math-fail" data="'.__( 'You did not enter in a correct math value', 'ideapush' ).'"></div>';
                
                //honey fail dialog
                $html .= '<div style="display: none;" id="dialog-honey-fail" data="'.__( 'It looks like you could be a robot, or alternatively please turn off any form autofill you have setup', 'ideapush' ).'"></div>';

                //file fail dialog
                $html .= '<div style="display: none;" id="dialog-file-fail" data="'.__( 'Please make sure all fields are completed', 'ideapush' ).'"></div>';

                //attachment fail dialog
                $html .= '<div style="display: none;" id="dialog-attachment-fail" data="'.__( 'Please make sure all fields are completed', 'ideapush' ).'"></div>';

                //login to vote title
                $html .= '<div style="display: none;" id="dialog-login-to-vote" data="'.__( 'Please enter your name and email to vote', 'ideapush' ).'"></div>';

                //login to vote required fields
                $html .= '<div style="display: none;" id="dialog-login-to-vote-required" data="'.__( 'Please ensure all fields are completed and a valid email is entered.', 'ideapush' ).'"></div>';

                //vote limit dialog
                $html .= '<div style="display: none;" id="dialog-no-vote" data="'.__( 'You have reached your daily vote limit or voting has been disabled on this board.', 'ideapush' ).'"></div>';

                //idea limit dialog
                $html .= '<div style="display: none;" id="dialog-no-idea" data="'.__( 'You have reached your daily idea creation limit or idea creation has been disabled on this board.', 'ideapush' ).'"></div>';
                
                //existing account
                $html .= '<div style="display: none;" id="dialog-existing-account" data="'.__( 'An account already exists with this email, please login to associate the idea with your existing account.', 'ideapush' ).'"></div>';
                
                //user profile error
                $html .= '<div style="display: none;" id="dialog-user-profile-error" data="'.__( 'Please ensure a first and last is completed and your email is a valid email.', 'ideapush' ).'"></div>';


                return $html;
            
            } else {
            //the person doesn't have permission to view the board
            
                return __( 'Sorry you do not have permission to view this board.', 'ideapush' );
            }   
            
            
        } else {
            //the board doesn't exist in the settings
            return __( 'The board number does not exist. Please create a board by going to: ', 'ideapush' ).'<a target="_blank" href="'.esc_url(get_admin_url(null,'/edit.php?post_type=idea&page=idea_push_settings')).'">'.__( 'IdeaPush > Settings > Boards', 'ideapush' ).'</a>.';  
        }

        
    } else {
        //there's no board parameter
        return __('Please ensure your shortcode parameter has a board number like: <code>[ideapush board="1"]</code>', 'ideapush' );    
    }
    
    
 
}
add_shortcode('ideapush', 'idea_push_board_shortcode');



?>